## ros-humble-rcdiscover 1.1.6

=== rcdiscover/CMakeLists.txt ===
# rcdiscover - the network discovery tool for Roboception devices
#
# Copyright (c) 2019 Roboception GmbH
# All rights reserved
#
# Author: Heiko Hirschmueller
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright notice,
# this list of conditions and the following disclaimer in the documentation
# and/or other materials provided with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its contributors
# may be used to endorse or promote products derived from this software without
# specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

project(rcdiscover CXX)

if (UNIX)
  find_package( Threads REQUIRED)
endif ()

add_definitions(-DHAVE_PCAP)

set(rcdiscover_src
        deviceinfo.cc
        discover.cc
        force_ip.cc
        operation_not_permitted.cc
        wol_exception.cc
        socket_exception.cc
        ping.cc
        wol.cc
        gige_request_counter.cc
        )
set(rcdiscover_hh
        deviceinfo.h
        discover.h
        force_ip.h
        operation_not_permitted.h
        wol_exception.h
        socket_exception.h
        socket.h
        ping.h
        wol.h
        gige_request_counter.h
        utils.h)

if (WIN32)
  set(rcdiscover_src ${rcdiscover_src} socket_windows.cc)
  set(rcdiscover_hh ${rcdiscover_hh} socket_windows.h)
else (WIN32)
  set(rcdiscover_src ${rcdiscover_src} socket_linux.cc)
  set(rcdiscover_hh ${rcdiscover_hh} socket_linux.h)
endif (WIN32)

# Static library
add_library(rcdiscover_static STATIC ${rcdiscover_src})
add_library(${PROJECT_NAMESPACE}::rcdiscover_static ALIAS rcdiscover_static)
if (UNIX)
    target_link_libraries (rcdiscover_static PUBLIC ${CMAKE_THREAD_LIBS_INIT})
endif(UNIX)
target_include_directories(rcdiscover_static
        PUBLIC
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}>
        $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}>)

target_compile_features(rcdiscover_static PUBLIC cxx_std_11)

# Install shared library
if (BUILD_RCDISCOVER_SHARED_LIB)
  message(STATUS "Building shared library: rcdiscover")
  add_library(rcdiscover SHARED ${rcdiscover_src})
  add_library(${PROJECT_NAMESPACE}::rcdiscover  ALIAS rcdiscover )
  target_include_directories(rcdiscover
          PUBLIC
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}>
        $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}>)

  target_compile_features(rcdiscover PUBLIC cxx_std_11)
  set_target_properties(rcdiscover PROPERTIES SOVERSION ${abiversion})
  target_compile_options(rcdiscover PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wall>)
  if (UNIX)
    target_link_libraries (rcdiscover ${CMAKE_THREAD_LIBS_INIT})
  endif(UNIX)

  install(TARGETS rcdiscover
          EXPORT PROJECTTargets
          COMPONENT bin
          ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
          LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
          RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
  install(FILES ${rcdiscover_hh} COMPONENT dev DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/rcdiscover)
endif()

=== debian/changelog ===
ros-humble-rcdiscover (1.1.6-1jammy) jammy; urgency=high

  * Always wait minimum of 1 seconds for getting responses to discovery request
  * CI, also build for jammy

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 07 Aug 2022 22:00:00 -0000

ros-humble-rcdiscover (1.1.5-1jammy) jammy; urgency=high

  * Changing label of filter from "Only Roboception devices" to "Only rc_... devices"
  * Trying to create a CI build job for an appimage (not yet complete)

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 29 Jun 2022 22:00:00 -0000

ros-humble-rcdiscover (1.1.4-1jammy) jammy; urgency=high

  * fix version in package.xml

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 14 Jul 2021 22:00:00 -0000

ros-humble-rcdiscover (1.1.3-1jammy) jammy; urgency=high

  * use target_compile_features instead of CMAKE_CXX_STANDARD
  * fix installation destination for package.xml

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 14 Jul 2021 22:00:00 -0000

ros-humble-rcdiscover (1.1.2-1jammy) jammy; urgency=high

  * update cmake files and packaging, requires cmake >= 3.1

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 13 Jun 2021 22:00:00 -0000

ros-humble-rcdiscover (1.1.1-1jammy) jammy; urgency=high

  * Ignore network unreachable socket error under Windows

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 15 Apr 2021 22:00:00 -0000

ros-humble-rcdiscover (1.1.0-1jammy) jammy; urgency=high

  * Treat all devices as comming from Roboception if model starts with either rc_visard or rc_cube

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 04 Feb 2021 23:00:00 -0000

ros-humble-rcdiscover (1.0.5-1jammy) jammy; urgency=high

  * Added building on CI for focal
  * persistently store window state

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 01 Oct 2020 22:00:00 -0000

ros-humble-rcdiscover (1.0.4-1jammy) jammy; urgency=high

  * only enable reset button and context menu entry for rc_visard devices
  * remove catkin build_export_depend from package.xml

 -- Felix Ruess <felix.ruess@roboception.de>  Fri, 03 Apr 2020 22:00:00 -0000

ros-humble-rcdiscover (1.0.3-1jammy) jammy; urgency=high

  * fix mapping of reachability flag in the GUI
  * more generic naming as it can also be used for other GEV devices
  * only show rc_visards in "reset" dialog

 -- Felix Ruess <felix.ruess@roboception.de>  Sat, 21 Mar 2020 23:00:00 -0000

ros-humble-rcdiscover (1.0.2-1jammy) jammy; urgency=high

  * Added filtering by model name in command line tool
  * Do not append alternative interface to output of cli if --serialonly or --iponly is given

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 11 Dec 2019 23:00:00 -0000

ros-humble-rcdiscover (1.0.1-1jammy) jammy; urgency=high

  * rename CMAKE options from INSTALL_x to BUILD_x
  * improve debian packaging via CPack

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 15 Sep 2019 22:00:00 -0000

ros-humble-rcdiscover (1.0.0-1jammy) jammy; urgency=high

  * fix wildcard matching
  * allow filtering by interface
  * print interface on which the device was found
  * also build shared lib for use in other packages
  * make it possible to release as ROS third party package

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 03 Jun 2019 22:00:00 -0000

ros-humble-rcdiscover (0.9.2-1jammy) jammy; urgency=high

  * GUI: fix WebGUI cannot be opened via context menu (GitHub issue #4)

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 09 Jan 2019 23:00:00 -0000

ros-humble-rcdiscover (0.9.0-1jammy) jammy; urgency=high

  * CLI: print model
  * extend CLI interface (SW-302)
    * reset
    * forceip
    * reconnect
  * show model on GUI (SW-300)
  * GUI: show complete package version in about dialog
  * fixed hidden buttons for Ubuntu Bionic

 -- Felix Ruess <felix.ruess@roboception.de>  Tue, 18 Dec 2018 23:00:00 -0000

ros-humble-rcdiscover (0.8.0-1jammy) jammy; urgency=high

  * add opying device info to clipboard
  * add device filter text field
  * Changed some dialog workflows
  * Added KUKA to manufacturer filter

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 11 Nov 2018 23:00:00 -0000

ros-humble-rcdiscover (0.7.0-1jammy) jammy; urgency=high

  * Added possibility to filter for name, serial number and mac address to command line tool
  * include <array> in utils

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 04 Jan 2018 23:00:00 -0000

ros-humble-rcdiscover (0.6.0-1jammy) jammy; urgency=high

  * add force IP command: setting of temporary IP address
  * add -serialonly flag for command line tool

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 08 Nov 2017 23:00:00 -0000

ros-humble-rcdiscover (0.5.0-1jammy) jammy; urgency=high

  * Optional disabling of RP filtering during installation on Ubuntu
  * Directed broadcasts on Windows

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 28 Sep 2017 22:00:00 -0000

ros-humble-rcdiscover (0.4.2-1jammy) jammy; urgency=high

  * add Desktop files and icons for debian
  * Disabled vectorization and binding to CUDA

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 30 Aug 2017 22:00:00 -0000

ros-humble-rcdiscover (0.4.1-1jammy) jammy; urgency=high

  * Fixed bug that prevented the main window from being closed once the help dialog was opened from the reset dialog

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 20 Aug 2017 22:00:00 -0000

ros-humble-rcdiscover (0.4.0-1jammy) jammy; urgency=high

  * Help buttons

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 03 Aug 2017 22:00:00 -0000

ros-humble-rcdiscover (0.3.2-1jammy) jammy; urgency=high

  * Build console application as Windows console application
  * Sign with SHA512

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 05 Jul 2017 22:00:00 -0000

ros-humble-rcdiscover (0.3.1-1jammy) jammy; urgency=high

  * Fixed rcdiscover console application

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 03 Jul 2017 22:00:00 -0000

ros-humble-rcdiscover (0.3.0-1jammy) jammy; urgency=high

  * Global broadcast instead of directed


=== debian/control ===
Source: ros-humble-rcdiscover
Section: misc
Priority: optional
Maintainer: Felix Ruess <felix.ruess@roboception.de>
Build-Depends: debhelper (>= 9.0.0), cmake, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-rcdiscover
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-humble-ros-workspace
Description: This package contains tools for the discovery of Roboception devices via GigE Vision.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-rcdiscover//opt/ros/humble/lib/:$(CURDIR)/debian/ros-humble-rcdiscover//opt/ros/humble/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install

## ros-humble-rcdiscover 1.1.7

=== debian/changelog ===
ros-humble-rcdiscover (1.1.7-1bookworm) bookworm; urgency=high

  * CI: remove bionic and appimage, add arm64 jammy
  * fix include cstdint for newer gcc versions

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 11 Mar 2024 16:00:00 -0000

ros-humble-rcdiscover (1.1.6-1bookworm) bookworm; urgency=high

  * Always wait minimum of 1 seconds for getting responses to discovery request
  * CI, also build for jammy

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 07 Aug 2022 16:00:00 -0000

ros-humble-rcdiscover (1.1.5-1bookworm) bookworm; urgency=high

  * Changing label of filter from "Only Roboception devices" to "Only rc_... devices"
  * Trying to create a CI build job for an appimage (not yet complete)

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 29 Jun 2022 16:00:00 -0000

ros-humble-rcdiscover (1.1.4-1bookworm) bookworm; urgency=high

  * fix version in package.xml

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 14 Jul 2021 16:00:00 -0000

ros-humble-rcdiscover (1.1.3-1bookworm) bookworm; urgency=high

  * use target_compile_features instead of CMAKE_CXX_STANDARD
  * fix installation destination for package.xml

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 14 Jul 2021 16:00:00 -0000

ros-humble-rcdiscover (1.1.2-1bookworm) bookworm; urgency=high

  * update cmake files and packaging, requires cmake >= 3.1

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 13 Jun 2021 16:00:00 -0000

ros-humble-rcdiscover (1.1.1-1bookworm) bookworm; urgency=high

  * Ignore network unreachable socket error under Windows

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 15 Apr 2021 16:00:00 -0000

ros-humble-rcdiscover (1.1.0-1bookworm) bookworm; urgency=high

  * Treat all devices as comming from Roboception if model starts with either rc_visard or rc_cube

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 04 Feb 2021 16:00:00 -0000

ros-humble-rcdiscover (1.0.5-1bookworm) bookworm; urgency=high

  * Added building on CI for focal
  * persistently store window state

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 01 Oct 2020 16:00:00 -0000

ros-humble-rcdiscover (1.0.4-1bookworm) bookworm; urgency=high

  * only enable reset button and context menu entry for rc_visard devices
  * remove catkin build_export_depend from package.xml

 -- Felix Ruess <felix.ruess@roboception.de>  Fri, 03 Apr 2020 16:00:00 -0000

ros-humble-rcdiscover (1.0.3-1bookworm) bookworm; urgency=high

  * fix mapping of reachability flag in the GUI
  * more generic naming as it can also be used for other GEV devices
  * only show rc_visards in "reset" dialog

 -- Felix Ruess <felix.ruess@roboception.de>  Sat, 21 Mar 2020 16:00:00 -0000

ros-humble-rcdiscover (1.0.2-1bookworm) bookworm; urgency=high

  * Added filtering by model name in command line tool
  * Do not append alternative interface to output of cli if --serialonly or --iponly is given

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 11 Dec 2019 16:00:00 -0000

ros-humble-rcdiscover (1.0.1-1bookworm) bookworm; urgency=high

  * rename CMAKE options from INSTALL_x to BUILD_x
  * improve debian packaging via CPack

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 15 Sep 2019 16:00:00 -0000

ros-humble-rcdiscover (1.0.0-1bookworm) bookworm; urgency=high

  * fix wildcard matching
  * allow filtering by interface
  * print interface on which the device was found
  * also build shared lib for use in other packages
  * make it possible to release as ROS third party package

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 03 Jun 2019 16:00:00 -0000

ros-humble-rcdiscover (0.9.2-1bookworm) bookworm; urgency=high

  * GUI: fix WebGUI cannot be opened via context menu (GitHub issue #4)

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 09 Jan 2019 16:00:00 -0000

ros-humble-rcdiscover (0.9.0-1bookworm) bookworm; urgency=high

  * CLI: print model
  * extend CLI interface (SW-302)
    * reset
    * forceip
    * reconnect
  * show model on GUI (SW-300)
  * GUI: show complete package version in about dialog
  * fixed hidden buttons for Ubuntu Bionic

 -- Felix Ruess <felix.ruess@roboception.de>  Tue, 18 Dec 2018 16:00:00 -0000

ros-humble-rcdiscover (0.8.0-1bookworm) bookworm; urgency=high

  * add opying device info to clipboard
  * add device filter text field
  * Changed some dialog workflows
  * Added KUKA to manufacturer filter

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 11 Nov 2018 16:00:00 -0000

ros-humble-rcdiscover (0.7.0-1bookworm) bookworm; urgency=high

  * Added possibility to filter for name, serial number and mac address to command line tool
  * include <array> in utils

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 04 Jan 2018 16:00:00 -0000

ros-humble-rcdiscover (0.6.0-1bookworm) bookworm; urgency=high

  * add force IP command: setting of temporary IP address
  * add -serialonly flag for command line tool

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 08 Nov 2017 16:00:00 -0000

ros-humble-rcdiscover (0.5.0-1bookworm) bookworm; urgency=high

  * Optional disabling of RP filtering during installation on Ubuntu
  * Directed broadcasts on Windows

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 28 Sep 2017 16:00:00 -0000

ros-humble-rcdiscover (0.4.2-1bookworm) bookworm; urgency=high

  * add Desktop files and icons for debian
  * Disabled vectorization and binding to CUDA

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 30 Aug 2017 16:00:00 -0000

ros-humble-rcdiscover (0.4.1-1bookworm) bookworm; urgency=high

  * Fixed bug that prevented the main window from being closed once the help dialog was opened from the reset dialog

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 20 Aug 2017 16:00:00 -0000

ros-humble-rcdiscover (0.4.0-1bookworm) bookworm; urgency=high

  * Help buttons

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 03 Aug 2017 16:00:00 -0000

ros-humble-rcdiscover (0.3.2-1bookworm) bookworm; urgency=high

  * Build console application as Windows console application
  * Sign with SHA512
